;(function load($) {

    if (!$.klear.checkDeps(['$.klearmatrix.module', '$.ui.form'], load)) {
        return;
    }

    var __namespace__ = "klearmatrix.list";

    $.widget("klearmatrix.list", $.klearmatrix.module, {
        options: {
            data: null,
            moduleName: 'list'
        },
        _intervals: {},
        _super: $.klearmatrix.module.prototype,
        _create: function () {
            this._super._create.apply(this);
        },
        _init: function () {

            this.options.data.title = this.options.data.title || this.options.title;

            var $appliedTemplate = this._loadTemplate("klearmatrixList");
            $(this.element.klearModule("getPanel")).append($appliedTemplate);

            this
                ._applyDecorators()
                ._registerBaseEvents()
                ._registerFieldsEvents()
                ._registerEvents();
        },
        destroy: function () {

            this._clearInterval();
            this._super.destroy.apply(this);
        },
        _clearInterval: function () {

            for (idx in this._intervals) {
                if (idx == $(this.element.klearModule("getPanel")).attr("id")) {
                    clearInterval(this._intervals[idx]);
                }
            }
        },
        _applyDecorators: function () {

            var self = this.element;
            var _self = this;

            $container = $(this.element.klearModule("getPanel"));

            $(".generalOptionsToolbar .action, .generalOptionsToolbar a", $container).button();

            if ($("td.multilang", $container).length > 0) {

                var $mlSelector = $("<span>").addClass("ui-silk ui-silk-comments mlTag").attr("title", $.translate("Field available in multi-language"));

                $("td.multilang", $container).each(function () {
                    $(this).prepend($mlSelector.clone().tooltip());
                });
            }

            $("caption span.extraCaptionInfo input", $container)
                .spinner()
                .on('keydown', function (e) {

                    if (e.keyCode == 13) {
                        $(this).trigger('fireit');
                    }
                })
                .on('fireit', function () {
                    var _count = parseInt($(this).val());
                    var _dispatchOptions = $(self).klearModule("option", "dispatchOptions");
                    if (!_dispatchOptions.post) _dispatchOptions.post = {};

                    $.extend(_dispatchOptions.post, {
                        count: _count
                    });

                    $(self)
                        .klearModule("option", "dispatchOptions", _dispatchOptions)
                        .klearModule("reDispatch");

                });


            return this;
        },
        _registerEvents: function () {
            var self = this.element;
            var _self = this;
            var panel = this.element.klearModule("getPanel");

            var tr = $('table.kMatrix tr', panel);

            $("td", tr).on('mouseenter mouseleave', function () {

                $("td:not(.options)", $(this).parent('tr')).toggleClass("ui-state-highlight");

                if (!$(this).is(".options") && $("a.option.default", $(this).parent('tr')).length > 0) {
                    $(this).parent('tr').toggleClass("pointer");
                    $("a.option.default", $(this).parent('tr')).toggleClass("ui-state-active");
                }

            }).on('mouseup', function (e) {
                // Haciendo toda la tupla clickable para la default option
                e.stopPropagation();
                e.preventDefault();
                if (document.getSelection() &&
                    document.getSelection().toString() != '' &&
                    $(document.getSelection().focusNode).parents("table.kMatrix").length == 1) {
                    return;
                }

                if ($(this).is(".options")) {
                    return;
                }

                if ($(this).hasClass("multiItem")) {
                    var $chkBox = $("input:checkbox", $(this));
                    $chkBox.prop('checked', !($chkBox.is(':checked')));
                    return;
                }
                // Modificador SHIFT + MultiItem => toggle checkbox
                if (e.shiftKey && $("td.multiItem", $(this).parent("tr")).length > 0) {
                    $("td.multiItem", $(this).parent("tr")).trigger("mouseup");
                    // Pequeño hack para deseleccionar el texto.
                    if (document.selection) {
                        document.selection.empty();
                    } else if (window.getSelection) {
                        window.getSelection().removeAllRanges();
                    }
                    return;
                }

                $.klear.checkNoFocusEvent(e, $(panel).parent(), $("a.option.default", $(this).parent('tr')));

                var $optionAnchor = $("a.option.default", $(this).parent('tr'));
                var event = ($optionAnchor.is(".screen")) ? "mouseup" : "click";
                $optionAnchor.trigger(event);

            });

            $('a._fieldOption', panel).on('mouseenter', function (e) {
                if ($(this).data("relatedtab")) {
                    $(this).data("relatedtab").klearModule("highlightOn");
                }
            }).on('mouseleave', function (e) {
                if ($(this).data("relatedtab")) {
                    $(this).data("relatedtab").klearModule("highlightOff");
                }
            });

            $(".paginator a", panel).on('click', function (e) {
                e.preventDefault();
                e.stopPropagation();

                var targetPage = $(this).data("page");

                var _dispatchOptions = $(self).klearModule("option", "dispatchOptions");

                if (!_dispatchOptions.post) _dispatchOptions.post = {};

                $.extend(_dispatchOptions.post, {
                    page: targetPage
                });

                $(self)
                    .klearModule("option", "dispatchOptions", _dispatchOptions)
                    .klearModule("reDispatch");

            });

            // REFRESCAR EL LISTADO
            var myTime = $('.generalOptionsToolbar .refresh', panel).data("auto-refresh");
            var iden = $(panel).attr("id");
            this._clearInterval();

            if (myTime) {
                $('.generalOptionsToolbar .refresh', panel).hide();
                this._intervals[iden] = setInterval(function () {
                    contadorRefresh()
                }, 1000);
            }

            function myInterval() {
                self._intervals(contInterval[iden]);
                $(self).klearModule("reDispatch");
            }

            function contadorRefresh() {

                var numTime = parseInt($('.generalOptionsToolbar .refresh:eq(0) .count', panel).html());
                var newTime = numTime - 1;

                if (numTime == 16) {
                    $('.generalOptionsToolbar .refresh', panel).fadeIn();
                }

                if (numTime == 1) {
                    _self._clearInterval();
                    $(self).klearModule("reDispatch");
                    return;
                }

                $('.generalOptionsToolbar .refresh .count', panel).html(newTime);
            }

            // DETENER EL REFRESCO DEL LISTADO
            $('.generalOptionsToolbar .refresh', panel).on('click', function (e) {
                e.preventDefault();
                e.stopPropagation();

                // DETENER
                clearInterval(_self._intervals[iden]);

                $('.generalOptionsToolbar .refresh', panel).fadeOut();
                $('.generalOptionsToolbar .refresh .count', panel).text(myTime);

                _self._intervals[iden] = setInterval(function () {
                    contadorRefresh()
                }, 1000);
            });

            // Orden de columnas
            $("th:not(.notSortable)", panel).on("click", function (e) {
                e.preventDefault();
                e.stopPropagation();

                var targetOrder = $(this).data("field");
                var orderType = $("span.asc", $(this)).length > 0 ? 'desc' : 'asc';

                var _dispatchOptions = $(self).klearModule("option", "dispatchOptions");

                if (!_dispatchOptions.post) _dispatchOptions.post = {};

                $.extend(_dispatchOptions.post, {
                    order: targetOrder,
                    orderType: orderType,
                    page: 1
                });

                $(self)
                    .klearModule("option", "dispatchOptions", _dispatchOptions)
                    .klearModule("reDispatch");
            }).css("cursor", "pointer");

            $("th.multiItem", panel).on("mouseup", function (e) {
                e.stopPropagation();
                e.preventDefault();
                var $chkBox = $("input:checkbox", $(this));
                var targetValue = !($chkBox.is(':checked'));
                $(".multiItem input:checkbox", panel).prop('checked', targetValue);
                return;
            }).css("cursor", "pointer");

            $(".multiItem input:checkbox", panel).on("click", function (e) {
                e.preventDefault();
            });

            $("th:not(.notSortable) span.filter", panel).on("click", function (e) {
                e.stopPropagation();
                e.preventDefault();
            });

            $("th.multiItem", panel).on('refreshButtons', function (e) {
                var numberOfChecks = $("td.multiItem input:checked", panel).length;
//                var disabled = (numberOfChecks == 0);
                $("a._generalOption[data-multiitem]", panel).each(function () {
                    if ($(this).data("alwaysenabled") === true) {
                        var disabled = false;
                    } else {
                        var disabled = (numberOfChecks == 0);
                    }
                    $(this).button("option", "disabled", disabled);
                    if (numberOfChecks > 0) {
                        $("sup", $(this)).html('(' + numberOfChecks + ')');
                    } else {
                        $("sup", $(this)).html('');
                    }
                });
                var headChecked = (numberOfChecks == $("td.multiItem input:checkbox", panel).length);
                $("th.multiItem input:checkbox", panel).prop('checked', headChecked);
            });

            $(".multiItem", panel).on('mouseup', function () {
                $("th.multiItem", panel).trigger('refreshButtons');
            });

            $("th.multiItem", panel).trigger('refreshButtons');


            $("span.mlTag", panel).on("click", function (e) {
                e.preventDefault();
                e.stopPropagation();
                var $td = $(this).parent("td");
                var shown = $("div.multilangValue:not(.selected)", $td).is(":visible");

                $("div.multilangValue:not(.selected)", $td).slideToggle();

                if (shown) {
                    $(".langIden", $td).animate({opacity: '0'});
                } else {
                    $(".langIden", $td).animate({opacity: '.5'});
                }

            }).on('mouseup', function (e) {
                // Paramos el evento mouseup, para no llegar al tr
                e.preventDefault();
                e.stopPropagation();
            });


            var $applyFilters = $("input[name=applyFilters]", panel);

            $(".klearMatrixFiltering p.applyFilters a", panel).on('click', function (e, noNewValue) {
                e.preventDefault();
                e.stopPropagation();

                var _dispatchOptions = $(self).klearModule("option", "dispatchOptions");
                _dispatchOptions.post = _dispatchOptions.post || {};
                if ($applyFilters.length > 0) {
                    _dispatchOptions.post.applySearchFilters = ( $applyFilters.is(':checked') ) ? 1 : 0;
                } else {
                    _dispatchOptions.post.applySearchFilters = 1;
                }
                _dispatchOptions.post.searchAddModifier = $("input[name=addFilters]:checked", panel).length;
                _dispatchOptions.post.page = 1;

                $(self)
                    .klearModule("option", "dispatchOptions", _dispatchOptions)
                    .klearModule("reDispatch");
            });

            $(".klearMatrixFiltering span.addTerm", panel).on('click', function (e, noNewValue) {
                e.preventDefault();
                e.stopPropagation();

                var $holder = $(this).parents(".klearMatrixFiltering");
                var $_term = $("input.term:visible", $holder).length
                    ? $("input.term", $holder)
                    : $("select.term", $holder);

                var $_field = $("select[name=searchField]", $holder);

                var _dispatchOptions = $(self).klearModule("option", "dispatchOptions");

                var fieldName = $_field.val();
                var fieldNameStr = $("option:selected", $_field).text();
                fieldNameStr = fieldNameStr.charAt(0).toUpperCase() + fieldNameStr.slice(1);

                _dispatchOptions.post = _dispatchOptions.post || {};
                _dispatchOptions.post.searchFields = _dispatchOptions.post.searchFields || {};
                _dispatchOptions.post.searchOps = _dispatchOptions.post.searchOps || {};

                _dispatchOptions.post.searchFields[fieldName] = _dispatchOptions.post.searchFields[fieldName] || [];
                _dispatchOptions.post.searchOps[fieldName] = _dispatchOptions.post.searchOps[fieldName] || [];

                if (noNewValue !== true) {
                    if (
                        (($_term.data('autocomplete')) && (!$_term.data('idItem')) )
                        || ($_term.val() == '')
                    ) {
                        $(this).parents(".filterItem:eq(0)").effect("shake", {times: 3}, 60);
                        return;
                    }

                    var isDatePicker = $_term.hasClass('hasDatepicker');
                    if (isDatePicker) {
                        var currentFormat = $_term.datepicker("option", 'dateFormat');
                        $_term.datepicker("option", 'dateFormat', 'yy-mm-dd');
                    }

                    var _newVal = ($_term.data('autocomplete')) ? $_term.data('idItem') : $_term.val();
                    var _newValStr =  $("input.term:visible", $holder).length
                        ? $_term.val()
                        : $("select.term option:selected", $holder).text();

                    if (isDatePicker) {
                        $_term.datepicker("option", 'dateFormat', currentFormat);
                    }

                    _dispatchOptions.post.searchFields[fieldName].push(_newVal);

                    var _searchOp = 'eq';
                    var _searchOpStr = '';
                    var _searchModifier = $('select.modifier:enabled', $holder);
                    if (_searchModifier.length) {
                        _searchOp = _searchModifier.val();
                    }

                    switch (_searchOp) {
                        case 'eq':
                        case 'exact':
                            break;
                        case 'lt':
                            _searchOpStr = '&lt;'
                            break;
                        case 'gt':
                            _searchOpStr = '&gt;'
                            break;
                        default:
                            _searchOpStr = $("option:selected", _searchModifier).text();
                    }

                    _dispatchOptions.post.searchOps[fieldName].push(_searchOp);
                }

                var searchAttr = $("span.field[data-field=" + fieldName + "]", $holder);
                var valueTpl =
                    '<span class="ui-widget-content ui-corner-all content" data-value="a" data-op="' + _searchOp + '">'
                        + '<strong>' + _searchOpStr + '</strong>'
                        + '<span data-idx="0" class="ui-silk inline ui-silk-cancel removable"></span>'
                        + _newValStr
                    + '</span>';

                if (searchAttr.length) {
                    searchAttr.append(
                        $(valueTpl)
                    );
                } else {
                    var searchTpl = $(
                        '<span data-field="' + fieldName + '" class="field">'
                        + '<strong>' + fieldNameStr + '</strong>:'
                            + valueTpl
                        + '</span>'
                    );

                    $('p.filteredFields', $holder).append(
                        searchTpl
                    );
                }

                if ($_term.get(0).tagName === 'INPUT') {
                    $_term.val('');
                }
            });

            $(".klearMatrixFiltering", panel).on('keydown', 'input.term', function (e) {

                if (e.keyCode == 13) {
                    // Wait for select event to happed (autocomplete)
                    var $target = $(this);
                    setTimeout(function () {
                        $("span.addTerm", $target.parents(".klearMatrixFiltering")).trigger("click");
                    }, 10);
                    e.preventDefault();
                    e.stopPropagation();
                }
            });

            $(".klearMatrixFiltering input[name=addFilters]", panel).on('change', function (e) {

                var _dispatchOptions = $(self).klearModule("option", "dispatchOptions");
                _dispatchOptions.post = _dispatchOptions.post || {};
                _dispatchOptions.post.searchAddModifier = $("input[name=addFilters]:checked", panel).length;
            });

            $applyFilters.on('change', function (e) {
                e.stopPropagation();
                e.preventDefault();
                $("p.searchNow a", panel).trigger("click", true);
            });

            $(".klearMatrixFiltering .filteredFields", panel).on('click', '.ui-silk-cancel', function (e) {

                var fieldName = $(this).parents("span.field:eq(0)").data("field");
                var idxToRemove = $(this).data("idx");
                var _dispatchOptions = $(self).klearModule("option", "dispatchOptions");

                if (!_dispatchOptions.post.searchFields[fieldName]) {
                    return;
                }
                _dispatchOptions.post.searchFields[fieldName].splice(idxToRemove, 1);
                _dispatchOptions.post.searchOps[fieldName].splice(idxToRemove, 1);
                _dispatchOptions.post.page = 1;

                var container = $(this).parents("span.field");
                if (container.children("span").length > 1) {
                    $(this).parent().remove();
                } else {
                    container.remove();
                }
            });

            $("button.preconfigureFilters", panel).button().on('click', function (e) {

                e.stopPropagation();
                e.preventDefault();
                var _dispatchOptions = $(self).klearModule("option", "dispatchOptions");

                _dispatchOptions.post = _dispatchOptions.post || {};
                _dispatchOptions.post.searchFields = _dispatchOptions.post.searchFields || {};
                _dispatchOptions.post.searchOps = _dispatchOptions.post.searchOps || {};

                var fieldName = $(this).data("field");
                var _newVal = $(this).data("value");
                var _searchOp = 'eq';
                if ($(this).data("ops")) {
                    _searchOp = $(this).data("ops");
                }

                _dispatchOptions.post.searchFields[fieldName] = _dispatchOptions.post.searchFields[fieldName] || [];
                _dispatchOptions.post.searchOps[fieldName] = _dispatchOptions.post.searchOps[fieldName] || [];

                _dispatchOptions.post.searchFields[fieldName].push(_newVal);
                _dispatchOptions.post.searchOps[fieldName].push(_searchOp);

                _dispatchOptions.post.searchAddModifier = $("input[name=addFilters]:checked", panel).length;
                _dispatchOptions.post.page = 1;

                $(self)
                    .klearModule("option", "dispatchOptions", _dispatchOptions)
                    .klearModule("reDispatch");

            });

            //Ocultamos botones preconfigurados que estén en activo en este momento
            $("p.filteredFields span.field", panel).each(function () {

                var $spanValues = $("span.content", $(this));
                var fieldName = $(this).data("field");

                $("button.preconfigureFilters", panel).filter(function () {

                    if (!$(this).data('field') ||
                        $(this).data('field') != fieldName ||
                        !$(this).data('value')) {
                        return false;
                    }

                    var candidateValue = $(this).data('value');

                    return $spanValues.filter(function () {
                            return (candidateValue == $(this).data("value"));
                        }).length > 0;

                }).button("disable");

            });

            $(".klearMatrixFilteringForm", panel).form();

            var currentPlugin = false;
            var originalSearchField = $(".klearMatrixFiltering input.term", panel).clone();

            var searchField = $("input.term", $container);
            var nullSearchFieldSpan = $("span.nullable", $container);
            nullSearchFieldSpan.hide();

            $("select.modifier", panel).on('change', function (event) {
                var currentVal = $(event.target).val();

                if (currentVal === 'exists') {
                    searchField.hide();
                    $("span.nullable", $container).show();
                } else {
                    $("span.nullable", $container).hide();
                    searchField.show();
                }
            });

            $(".klearMatrixFiltering select[name=searchField]", panel).on('manualchange.searchValues', function (e, manual) {

                var column = $.klearmatrix.template.helper.getColumn(_self.options.data.columns, $(this).val());
                var $container = $(".klearMatrixFiltering", panel);

                var searchOption = $("span.searchOption", $container);
                var searchSelector = $("select[name=searchOption]", $container);

                var stringSearchOption = $("span.stringSearchOption", $container);
                var stringSearchSelector = $("select[name=stringSearchOption]", $container);

                var numericSearchOption = $("span.numericSearchOption", $container);
                var numericSearchSelector = $("select[name=numericSearchOption]", $container);

                var nullSearchSelector = $("option[value='exists']", numericSearchSelector);

                if (false !== currentPlugin) {

                    searchField[currentPlugin]("destroy");
                    currentPlugin = false;
                }

                var _newField = originalSearchField.clone();
                searchField = searchField.replaceWith(_newField);
                searchField = _newField;

                column.search = column.search || {};

                if (column.config && column.config['values']) {
                    column.search.options = null;
                } else if (column.config && column.config['plugin'] && column.config['plugin'].match(/date|time/g)) {
                    column.search.options = 'time';
                } else if (column.search && column.search['as'] && column.search['as'] === 'numeric') {
                    column.search.options = 'numeric';
                } else {
                    column.search.options = 'string';
                }

                //Reset positions
                $('select.modifier', $container).each(function (item) {
                    $('option:eq(0)', this).prop('selected', 'selected');
                });

                if (column.search.options === 'time') {
                    searchSelector.prop('disabled', false);
                    searchOption.show();

                    stringSearchSelector.prop('disabled', 'disabled');
                    stringSearchOption.hide();

                    numericSearchSelector.prop('disabled', 'disabled');
                    numericSearchOption.hide();
                } else if (column.search.options === 'string') {
                    stringSearchSelector.prop('disabled', false);
                    stringSearchOption.show();

                    searchSelector.prop('disabled', 'disabled');
                    searchOption.hide();

                    numericSearchSelector.prop('disabled', 'disabled');
                    numericSearchOption.hide();
                } else if (column.search.options === 'numeric') {
                    numericSearchSelector.prop('disabled', false);
                    if (column.properties.required === false) {
                        nullSearchSelector.prop('disabled', false);
                    } else {
                        nullSearchSelector.prop('disabled', 'disabled');
                    }

                    numericSearchSelector.data("selectBoxIt").refresh();
                    numericSearchOption.show();

                    searchSelector.prop('disabled', 'disabled');
                    searchOption.hide();

                    stringSearchSelector.prop('disabled', 'disabled');
                    stringSearchOption.hide();
                } else {
                    searchSelector.prop('disabled', 'disabled');
                    searchOption.hide();

                    stringSearchSelector.prop('disabled', 'disabled');
                    stringSearchOption.hide();

                    numericSearchSelector.prop('disabled', 'disabled');
                    numericSearchOption.hide();
                }

                $container.find("span.infoShow").remove();
                $container.find("div.infoDiv").remove();

                var visibleModifier = $("span.searchModifier:visible select", panel);
                if (visibleModifier.length) {
                    visibleModifier.trigger('change');
                } else {
                    $("span.nullable", panel).hide();
                }

                if (column.search.info) {
                    $("<span />")
                        .attr("class", "infoShow ui-silk ui-silk-help inline")
                        .prependTo($(".filterItem", $container))
                        .on('click', function (e) {
                            if ($('div.infoDiv').is(':visible')) {
                                $('div.infoDiv').slideUp('fast');
                            } else {
                                $('div.infoDiv').slideDown('fast');
                            }
                        });

                    $("<div>" + column.search.info + "</div>")
                        .attr("class", "infoDiv hidden")
                        .prependTo($(".filterItem", $container));
                }

                switch (true) {
                    // un select!
                    case  (column.type == 'select'):
                    case  (column.type == 'multiselect'):
                        var _availableValues = $.klearmatrix.template.helper.getValuesFromSelectColumn(column);

                        var sourcedata = [];
                        $.each(_availableValues, function (i, val) {
                            sourcedata.push({label: val, id: i});
                        });

                        searchField.autocomplete({
                            minLength: 0,
                            source: sourcedata,
                            select: function (event, ui) {
                                searchField.val(ui.item.label);
                                searchField.data('idItem', ui.item.id);
                                return false;
                            }
                        }).data("autocomplete")._renderItem = function (ul, item) {
                            return $("<li></li>")
                                .data("item.autocomplete", item)
                                .append("<a>" + item.label + "</a>")
                                .appendTo(ul);
                        };
                        currentPlugin = 'autocomplete';

                        break;

                    // TODO, hacer que esta configuración venga de serie en column.search
                    case (column.config && typeof column.config['plugin'] == 'string'):
                        var _pluginName = column.config['plugin'];
                        currentPlugin = _pluginName;
                        var _settings = column.config['settings'] || {};
                        searchField[_pluginName](_settings);
                        break;

                    case (column.search.plugin && typeof column.search.plugin == 'string'):
                        var _pluginName = column.config['plugin'];
                        currentPlugin = column.search.plugin;
                        var _settings = column.search.settings || {};
                        searchField[column.search.plugin](_settings);
                        break;

                    default:

                        break;
                }

                if (manual !== true && !$(searchField).hasClass("hasDatepicker")) {
                    searchField.focus();
                }

            }).trigger('manualchange.searchValues', true);

            $(".klearMatrixFiltering select[name=searchField]", panel).trigger("manualchange");

            var $filteredFields = $(".klearMatrixFiltering .filteredFields", panel);
            $(".klearMatrixFiltering .title", panel).on('click', function (e, i) {
                var $searchForm = $(this).parents("form:eq(0)");
                var filterItem = ".filterItem";
                var applyButton = $('p.searchNow', $searchForm.parent());

                if ($applyFilters.is(':checked') == false
                    && $filteredFields.find('.field').length > 0) {
                    filterItem = ".filteredFields";
                }

                if ($searchForm.hasClass("not-loaded")) {
                    $(filterItem, $searchForm).slideDown(function () {
                        $searchForm.removeClass("not-loaded");
                    });
                    applyButton.slideDown();
                } else {
                    $(filterItem, $searchForm, applyButton).slideUp(function () {
                        $searchForm.addClass("not-loaded");
                    });
                    applyButton.slideUp();
                }
            });

            if ($applyFilters.is(':checked') == false
                && $filteredFields.find('.field').length > 0) {
                $filteredFields.css('opacity', '0.5');
                $filteredFields.unbind('click');
                $('.preconfiguredFilters, .filterItem', panel).hide();
                $('.preconfiguredFilters, .searchNow', panel).hide();

                $(".klearMatrixFilteringForm:eq(0)", panel).addClass('not-loaded');
            }

            //Exportar a CSV el listado
            $("a.option.csv", panel).on('click', function (event) {
                event.preventDefault();
                event.stopPropagation();

                var _dispatchOptions = $(self).klearModule("option", "dispatchOptions");

                if (!_dispatchOptions.post) {

                    _dispatchOptions.post = {};
                }

                var _tmpOptions = {};
                $.extend(_tmpOptions, _dispatchOptions.post);
                _tmpOptions['format'] = 'csv';


                var reqOpts = {
                    file: $(self).klearModule("option", "file"),
                    type: 'screen',
                    screen: _self.options.data.screen,
                    post: _tmpOptions,
                    external: true

                };


                if (_dispatchOptions.pk != undefined) {
                    reqOpts.pk = _dispatchOptions.pk;
                    reqOpts.screen = _dispatchOptions.screen;
                }
                var $button = $(this);
                $button.button("option", "disabled", true);
                $("span.ui-silk", $button).addClass("spining");
                var curTitle = $button.attr("title");
                $button.attr("title", $.translate("Loading content")).tooltip();

                $.klear.request(reqOpts, function () {
                    $button.button("option", "disabled", false);
                    $button.tooltip('close').attr("title", curTitle).tooltip();
                    $("span.ui-silk", $button).removeClass("spining");
                }, function () {
                    $(self).klearModule("showDialogError", $.translate("Error download CSV file.") + '<br />' + $.translate("Please contact administrator."),
                        {
                            title: $.translate("Error")
                        }
                    );

                    $button.button("option", "disabled", false);
                    $button.tooltip('close').attr("title", curTitle).tooltip();
                    $("span.ui-silk", $button).removeClass("spining");
                });
            });

            //Autocompletes
            var autocompleteNodes = {};
            var autocompleteEntities = {};

            $("span.autocomplete", panel).each(function () {

                var identifier = $(self).klearModule("option", "file") + "_" + $(this).data("command");
                if (!autocompleteEntities[identifier]) {

                    var _post = $(this).data();
                    _post.value = new Array;

                    var requestData = {
                        file: $(self).klearModule("option", "file"),
                        type: 'command',
                        post: _post
                    };

                    if (!$(this).data('command')) {
                        $.console.log("ATENCIÓN: El atributo command no está configurado. Se utiliza el valor por defecto: " + $(this).data('fielddecorator') + "_command");
                        requestData['command'] = $(this).data('fielddecorator') + "_command";
                    }

                    autocompleteEntities[identifier] = requestData;
                    autocompleteNodes[identifier] = new Array;
                }

                autocompleteEntities[identifier].post.value.push($(this).attr("data-value"));
                autocompleteNodes[identifier].push(this);
            });

            $.each(autocompleteEntities, function (idx) {

                var request = $.klear.buildRequest(this);
                var nodes = autocompleteNodes;

                var _url = request.action;
                _url += '&' + $.param(request.data);
                $.getJSON(_url, function (data, status, xhr) {
                    $.each(nodes[idx], function () {

                        var currentNode = $(this);
                        var currentNodeData = data.results["'" + currentNode.attr("data-value") + "'"];
                        if (!currentNodeData) {
                            return;
                        }

                        var results = new Array();
                        if (Object.prototype.toString.call(currentNodeData) === '[object Array]') {
                            for (var key in currentNodeData) {
                                results.push(currentNodeData[key].label);
                            }
                        } else {
                            results.push(currentNodeData.label);
                        }
                        $(this).replaceWith(results.join(", "));
                    });
                });
            });

            return this;
        }
    });

    $.widget.bridge("klearMatrixList", $.klearmatrix.list);

})(jQuery);
